
#include "windows.h"
#include "DS_Filter.h"
#include "math.h"
#include "helpids.h"

#define MAX_HEIGHT  576
#define MAX_WIDTH   768

#pragma pack (16)

//#define SAVEPICT 1

const __int64 colorvalue = 0x8000800080008000;
const __int64 colormask = 0x00ff00ff00ff00ff;
const __int64 constffff = 0xffffffffffffffff;
const __int64 constcolors = 0x8080808080808080;

__declspec(align(16)) DWORD colormask128[4] = {0x00ff00ff,0x00ff00ff,0x00ff00ff,0x00ff00ff};
__declspec(align(16)) DWORD colorvalue128[4] = {0x80008000,0x80008000,0x80008000,0x80008000};

#define tv1000first12test 0x96

BYTE tv1000data[70] = {0x58,0,0x73,0,0xd8,0,0x83,0,0x88,0,0x57,0,0x75,0,0xf7,0,
					   0xc6,0,0x6b,0,0x75,0,0xb2,0,0xb2,0,0x33,0,0x83,0,0xaa,0,
					   0x1b,0,0xc8,0,0xe8,0,0xf4,0,0x40,0,0xa6,0,0x52,0,0x47,0,
					   0xc4,0,0xbc,0,0x8f,0,0x32,0,0x8f,0,0x19,0,0x78,0,0xa2,0,
					   0x9a,0,0x40,0,0x54,0};

BYTE tv1000dataz[18] = {0x65,0xad,0x6f,0xb6,0x98,0x93,0x72,0x96,0x71,
						0xee,0x73,0x4c,0xc0,0x60,0x54,0x8d,0x6d,0x72};
BYTE tv1000dataz720[40] = {0x59,0x66,0xb9,0xac,0x71,0x73,0x58,0xb6,0xbd,
						   0xda,0x7b,0x73,0x88,0xa3,0x99,0x26,0xa1,0x8e,0x2f,
						   0xb5,0xe6,0xf4,0xaa,0x51,0xa5,0x41,0x70,0xc0,0xc9,
						   0xac,0x53,0x71,0x49,0x91,0x97,0xae,0x48,0x4d,0xa0,0x4b};


BOOL          IsInitialised = FALSE;
int           PictureWidth = -1;
int           PictureHeight = -1;

#if defined (SAVEPICT)
BOOL notsaved = TRUE;
BOOL savepic = FALSE;
#endif

TCHAR copyright[76] = "(C) 2002 Programmed by Kisa Kaunas Lithuania.Use for testing purposes only!";
WORD zonelength = 88;
BYTE testvalue = 50;
BYTE counter = 40;
BYTE counterzone = 5;
BOOL BigZone = FALSE;
BOOL BlackPixels = FALSE;
BOOL ZoomPixels = FALSE;
BOOL Method2 = FALSE;
BOOL UseHistory = TRUE;

__declspec(align(16)) BYTE zxbuf[MAX_WIDTH*2*2];
__declspec(align(16)) BYTE zxbuf2[MAX_WIDTH*2*2];

FILTER_METHOD DalviDecoder2Method;

typedef enum
{
    USEDALVIDECODER2FILTER = 0,
	USEBIGZONE,
	USEBLACKPIXELSONLY,
	USEZOOM,
	USEMETHOD2,
	USEPREVIOUS,
    FLT_DALVI_DEC2_SETTING_LASTONE,
} FLT_DALVI_DEC2_SETTING;

#define WM_FLT_DALVI_DEC2_GETVALUE     (WM_APP + 88)
#define WM_FLT_DALVI_DEC2_SETVALUE     (WM_APP + 188)
#define WM_FLT_DALVI_DEC2_CHANGEVALUE  (WM_APP + 288)

#if defined (SAVEPICT)
void savepict(BYTE* destline)
{
	DWORD bytesw;
	HANDLE hfile = CreateFile("test.ddd",
				GENERIC_WRITE,
				0,
				NULL,
				CREATE_NEW,
				FILE_ATTRIBUTE_NORMAL,
				NULL);
	WriteFile(hfile,
			  destline,
			  PictureWidth*PictureHeight*2,
			  &bytesw,
			  NULL);
	_asm
	{
		mov esi,offset zxbuf
		mov eax,PictureWidth
		mov [esi],eax
		mov eax,PictureHeight
		mov [esi+4],eax
	}

	WriteFile(hfile,
			  &zxbuf,
			  8,
			  &bytesw,
			  NULL);


	CloseHandle(hfile);


	return;
}

#endif

void changemyzone()
{
	switch (PictureWidth)
	{
		case  720:
			zonelength = 88;
		break;
		case 384:
			zonelength = 48;
		case 320:
			zonelength = 40;
		break;
		default:
		break;
	}
	return;

}


void DecodeSettings(BYTE* sourceline,int linelen)
{
	_asm
	{
		mov esi,sourceline
		mov edx,PictureHeight
		mov bl,0
maniloop:
		push edx
		push esi
		mov ecx,PictureWidth
		mov ah,-1
		add esi,ecx
		add esi,ecx
		movzx ecx,zonelength
//		cmp ecx,94
//		jae zoneok
//		mov ecx,94
//zoneok:
		sub esi,2
innerllop:
		mov al,[esi]
//		sub al,16
		cmp al,ah
		jae noblacker
		mov ah,al
noblacker:
		sub esi,2
		dec ecx
		jnz innerllop
		cmp ah,bl
		jbe nobrighter
		mov bl,ah
nobrighter:
		pop esi
		mov eax,linelen
		add esi,eax
		pop edx
		dec edx
		jnz maniloop
		cmp bl,9
		ja pok
		mov bl,10
pok:
		add bl,5
		mov testvalue,bl
	}
	return;
}

void DecodeZone(BYTE* sourceline,int linelen)
{
	_asm
	{
		mov ah,testvalue
		mov edi,sourceline
		mov edx,PictureHeight
		xor ebx,ebx
mainloop:
		push edi
		mov ecx,PictureWidth
		add edi,ecx
		add edi,ecx
		sub edi,2
innerloop:		
		mov al,[edi]
		cmp al,ah
		jb endpixel
		sub edi,2
		dec ecx
		jnz innerloop
		jmp nextline
endpixel:
		mov edi,PictureWidth
		sub edi,ecx
		cmp edi,ebx
		jb nextline
		mov ebx,edi
nextline:
		pop edi
		mov ecx,linelen
		add edi,ecx
		dec edx
		jnz mainloop
		mov eax,88
		cmp ebx,92
		jb smallzone
		mov eax,720
smallzone:
		mov zonelength,ax

	}
	return;
}

void DetectTV1000(BYTE* pixels,DWORD pitch)
{
	DWORD tv1000d = (DWORD)&tv1000data;
	DWORD dest;

	_asm
	{
		mov esi,pixels
		mov eax,34
		mov ecx,pitch
		imul ecx
		add esi,eax
		mov dest,esi
		mov edi,offset zxbuf
		mov ecx,PictureWidth
		mov eax,ecx
		add eax,eax
		shr ecx,3
		movq mm4,colormask
ms0:
/*
		movq mm0,[esi]
		movq mm1,[esi+8]
		movq [edi],mm0
		movq [edi+8],mm1
		movq [edi+eax],mm0
		movq [edi+eax+8],mm1
*/
		movaps xmm0,[esi]
		add esi,16
		movaps [edi],xmm0
		movaps [edi+eax],xmm0
		add edi,16
		dec ecx
		jnz ms0

		mov edx,-1
		mov ecx,PictureWidth
		movzx eax,zonelength
		sub ecx,eax
		jns notoverwrapped
		xor ecx,ecx

notoverwrapped:

		pxor mm5,mm5
		mov edi,offset zxbuf
		mov esi,tv1000d
		add edi,ecx
		add edi,ecx
/*
		movq mm0,[edi]
		movq mm1,[edi+4]
		movq mm2,[edi+8]
		movq mm3,[edi+12]
		pminub mm0,mm1
		pminub mm2,mm3
		movq mm1,[edi+16]
		movq mm3,[edi+20]
		pminub mm0,mm2
		pminub mm1,mm3
		pminub mm0,mm1
		movq mm2,mm0
		psrlq mm0,32
		pminub mm0,mm2
		movq mm2,mm0
		psrlq mm0,16
		pminub mm0,mm2
		movd eax,mm0
		cmp al,0x2f
		jb znotgood

		cmp byte ptr [edi+16*2],tv1000first12test
		ja znotgood
		cmp byte ptr [edi+18*2],tv1000first12test
		jb znotgood
		cmp byte ptr [edi+20*2],tv1000first12test
		ja znotgood
*/
/*
		mov al,[edi+16*2]
		mov ah,[edi+18*2]
		cmp al,ah
		ja znotgood
		mov al,[edi+20*2]
		cmp ah,al
		jb znotgood

		mov al,[edi+22*2]
		mov ah,[edi+24*2]
		cmp al,ah
		ja znotgood
		mov al,[edi+26*2]
		jb znotgood
*/
		push ecx
		mov ecx,70

		shr ecx,4
ms7:

		movq mm0,[edi]
		movq mm1,[esi]
		movq mm2,[edi+8]
		movq mm3,[esi+8]
		
		pand mm0,mm4
		pand mm1,mm4
		pand mm2,mm4
		pand mm3,mm4
		psadbw mm0,mm1
		psadbw mm2,mm3
		paddd mm5,mm0
		movq mm0,[edi+16]
		movq mm1,[esi+16]
		paddd mm5,mm2
		psadbw mm0,mm1
		movq mm2,[edi+24]
		movq mm3,[esi+24]
		paddd mm5,mm0
		add edi,32
		psadbw mm2,mm3
		add esi,32
		paddd mm5,mm2

		dec ecx
		jnz ms7

		pop ecx

		movd eax,mm5
		cmp eax,edx
		ja znotgood

		mov edx,eax
		mov ebx,ecx

znotgood:
		inc ecx
		cmp ecx,PictureWidth
		jb notoverwrapped

		add ebx,51
		cmp ebx,PictureWidth
		jb ms4
		sub ebx,PictureWidth
ms4:
		mov edi,dest
		mov esi,offset zxbuf
		add esi,ebx
		add esi,ebx
		mov ecx,PictureWidth
		shr ecx,4
		movq mm6,colormask
		movq mm7,colorvalue
ms8:
		movq mm0,[esi]
		movq mm1,[esi+8]
		movq mm2,[esi+16]
		movq mm3,[esi+24]
		pand mm0,mm6
		pand mm1,mm6
		pand mm2,mm6
		pand mm3,mm6
		por mm0,mm7
		por mm1,mm7
		por mm2,mm7
		por mm3,mm7
		movq [edi],mm0
		movq [edi+8],mm1
		movq [edi+16],mm2
		movq [edi+24],mm3
		add esi,32
		add edi,32
		dec ecx
		jnz ms8
	}
	return;
}

void DetectTV10002(BYTE* destline)
{
	DWORD lresult;
	_asm
	{
		mov esi,destline
		mov edi,offset zxbuf
		mov ecx,PictureWidth
		shr ecx,1
myloop2:
		movzx ebx,byte ptr [esi]
		movzx eax,byte ptr [esi+2]
		add eax,ebx
		shr eax,1
		mov [edi],al
		add esi,4
		inc edi
		dec ecx
		jnz myloop2
		mov ecx,PictureWidth
		shr ecx,1
		mov esi,offset zxbuf
		rep movsb

		mov eax,PictureWidth
		cmp eax,720
		je search720

		mov edx,-1
		xor ecx,ecx
notover:
		push ecx
		xor ebx,ebx
		mov esi,offset tv1000dataz
		mov edi,offset zxbuf
		add edi,ecx
		mov ecx,18
myloop3:
		mov al,[esi]
		sub al,[edi]
		jns not_negs
		neg al
not_negs:
		movzx eax,al
		add ebx,eax
		inc esi
		inc edi
		dec ecx
		jnz myloop3
		pop ecx
		cmp ebx,edx
		ja znotgood
		mov edx,ebx
		mov lresult,ecx
znotgood:
		inc ecx
		mov eax,PictureWidth
		shr eax,1
		cmp ecx,eax
		jb notover

		mov ebx,lresult
		add ebx,ebx
		add ebx,50
		cmp ebx,PictureWidth
		jb ms03
		sub ebx,PictureWidth
ms03:

		jmp wrap

search720:

		mov edx,-1
		xor ecx,ecx
not7over:
		push ecx
		xor ebx,ebx
		mov esi,offset tv1000dataz720
		mov edi,offset zxbuf
		add edi,ecx
		mov ecx,40
my7loop3:
		mov al,[esi]
		sub al,[edi]
		jns not7_negs
		neg al
not7_negs:
		movzx eax,al
		add ebx,eax
		inc esi
		inc edi
		dec ecx
		jnz my7loop3
		pop ecx
		cmp ebx,edx
		ja znot7good
		mov edx,ebx
		mov lresult,ecx
znot7good:
		inc ecx
		mov eax,PictureWidth
		shr eax,1
		cmp ecx,eax
		jb not7over

		mov ebx,lresult
		add ebx,ebx
		add ebx,115
		cmp ebx,PictureWidth
		jb ms02
		sub ebx,PictureWidth
ms02:
		

wrap:
		mov esi,destline
		mov edi,offset zxbuf
		mov eax,PictureWidth
		shl eax,1
		mov ecx,PictureWidth
		shr ecx,3
mops:
		movq mm0,[esi]
		movq mm1,[esi+8]
		movq [edi],mm0
		movq [edi+8],mm1
		movq [edi+eax],mm0
		movq [edi+eax+8],mm1
		add edi,16
		add esi,16
		dec ecx
		jnz mops

		movq mm6,colormask
		movq mm7,colorvalue
		mov edi,destline
		mov esi,offset zxbuf
		add ebx,ebx
		add esi,ebx
		mov ecx,PictureWidth
		shr ecx,3
mops2:
		movq mm0,[esi]
		movq mm1,[esi+8]
		pand mm0,mm6
		pand mm1,mm6
		por mm0,mm7
		por mm1,mm7
		movq [edi],mm0
		movq [edi+8],mm1
		add edi,16
		add esi,16
		dec ecx
		jnz mops2
	}
	return;
}



void DecodeFirstLine(BYTE* sourcline)
{
	_asm
	{
/*
		mov esi,sourcline
		mov edi,offset zxbuf
		mov ecx,PictureWidth
		mov eax,ecx
		shl eax,1
		shr ecx,3
ms0:
		movq mm0,[esi]
		movq mm1,[esi+8]
		movq [edi],mm0
		movq [edi+8],mm1
		movq [edi+eax],mm0
		movq [edi+eax+8],mm1
		add esi,16
		add edi,16
		dec ecx
		jnz ms0

		mov esi,sourcline
		xor edx,edx
		mov ecx,PictureWidth
		mov ebx,ecx
		add esi,ecx
		add esi,ecx
		sub esi,2
		movzx ecx,zonelength
		mov ah,0xff
cddd1:
		mov al,[esi]
		sub al,16
		cmp al,ah
		jae cddd
		mov ah,al
		mov edx,ebx
cddd:
		sub esi,2
		dec ebx
		dec ecx
		jnz cddd1
*/
//		mov edi,offset zxbuf
//		shl edx,1
//		add edi,edx
		mov ecx,PictureWidth
		shr ecx,3
		mov esi,sourcline
		movq mm6,colormask
		movq mm7,colorvalue
ms8:
		movq mm0,[esi]
		movq mm1,[esi+8]
		pand mm0,mm6
		pand mm1,mm6
		por mm0,mm7
		por mm1,mm7
		movq [esi],mm0
		movq [esi+8],mm1
		add esi,16
		add edi,16
		dec ecx
		jnz ms8

	}
	return;
}

void DecodeTV1000Line(BYTE* destline,BYTE* sourcline)
{
	_asm
	{
		pxor mm7,mm7
		mov edi,offset zxbuf
		mov esi,destline
		mov ecx,PictureWidth
		mov eax,ecx
		shr ecx,3
		shl eax,1
ms0:

		movq mm0,[esi]
		movq mm1,[esi+8]
		movq [edi],mm0
		movq [edi+8],mm1
		movq [edi+eax],mm0
		movq [edi+eax+8],mm1

		add esi,16
		add edi,16

		dec ecx
		jnz ms0

		mov edx,-1
		mov ecx,PictureWidth
		movzx eax,zonelength
		sub ecx,eax
		jns notoverwrapped
		xor ecx,ecx

notoverwrapped:

		pxor mm5,mm5
		mov edi,offset zxbuf
		mov esi,sourcline
		add edi,ecx
		add edi,ecx
		mov eax,[edi]
		push ecx
		mov ecx,PictureWidth

		shr ecx,4
ms7:

		movq mm0,[edi]
		movq mm1,[esi]
		movq mm2,[edi+8]
		movq mm3,[esi+8]

		psadbw mm0,mm1
		psadbw mm2,mm3
		paddd mm5,mm0
		movq mm0,[edi+16]
		movq mm1,[esi+16]
		paddd mm5,mm2
		psadbw mm0,mm1
		movq mm2,[edi+24]
		movq mm3,[esi+24]
		paddd mm5,mm0
		add edi,32
		psadbw mm2,mm3
		add esi,32
		paddd mm5,mm2
		dec ecx
		jnz ms7

		pop ecx

		movd eax,mm5
		cmp eax,edx
		ja znotgood

		mov edx,eax
		mov ebx,ecx

znotgood:
		inc ecx
		cmp ecx,PictureWidth
		jb notoverwrapped

		mov edi,destline
		mov esi,offset zxbuf
		mov ecx,ebx
		add esi,ecx
		add esi,ecx
		mov ecx,PictureWidth
		shr ecx,3
		movq mm6,colormask
		movq mm7,colorvalue
ms8:
		movq mm0,[esi]
		movq mm1,[esi+8]
		pand mm0,mm6
		pand mm1,mm6
		por mm0,mm7
		por mm1,mm7
		movq [edi],mm0
		movq [edi+8],mm1
		add esi,16
		add edi,16
		dec ecx
		jnz ms8
		emms
	}
	return;
}


void DecodeLine(BYTE* destline,BYTE* sourcline)
{
	_asm
	{
		movq mm6,colormask
		mov edi,offset zxbuf
		mov esi,destline
		mov ecx,PictureWidth
		mov eax,ecx
		shr ecx,4
ms0:

		movq mm0,[esi]
		movq mm1,[esi+8]
		movq mm2,[esi+16]
		movq mm3,[esi+24]

		pand mm0,mm6
		pand mm1,mm6
		pand mm2,mm6
		pand mm3,mm6

		packuswb mm0,mm1
		packuswb mm2,mm3
		movq [edi],mm0
		movq [edi+8],mm2
		movq [edi+eax],mm0
		movq [edi+eax+8],mm2

		add edi,16
		add esi,32
		dec ecx
		jnz ms0

		mov edi,offset zxbuf2
		mov esi,sourcline
		mov ecx,PictureWidth
		mov eax,ecx
		shr ecx,4
ms007:

		movq mm0,[esi]
		movq mm1,[esi+8]
		movq mm2,[esi+16]
		movq mm3,[esi+24]

		pand mm0,mm6
		pand mm1,mm6
		pand mm2,mm6
		pand mm3,mm6

		packuswb mm0,mm1
		packuswb mm2,mm3
		movq [edi],mm0
		movq [edi+8],mm2
		movq [edi+eax],mm0
		movq [edi+eax+8],mm2

		add edi,16
		add esi,32
		dec ecx
		jnz ms007

		mov edx,-1
		mov ecx,PictureWidth
		movzx eax,zonelength
		sub ecx,eax
		jns notoverwrapped
		xor ecx,ecx

notoverwrapped:

		pxor mm5,mm5
		mov edi,offset zxbuf
		mov esi,offset zxbuf2
		add edi,ecx
//		add edi,ecx
		mov eax,[edi]
		cmp al,testvalue
		ja znotgood
//		sub al,16
//		cmp al,testvalue
//		jb zveryok
//		cmp ah,testvalue
//		ja znotgood
//zveryok:
		push ecx
		mov ecx,PictureWidth

		shr ecx,5
ms7:

		movq mm0,[edi]
		movq mm1,[esi]
		movq mm2,[edi+8]
		movq mm3,[esi+8]

		psadbw mm0,mm1
		psadbw mm2,mm3
		paddd mm5,mm0
		movq mm0,[edi+16]
		movq mm1,[esi+16]
		paddd mm5,mm2
		psadbw mm0,mm1
		movq mm2,[edi+24]
		movq mm3,[esi+24]
		paddd mm5,mm0
		add edi,32
		psadbw mm2,mm3
		add esi,32
		paddd mm5,mm2
		dec ecx
		jnz ms7

		pop ecx

		movd eax,mm5
		cmp eax,edx
		ja znotgood

		mov edx,eax
		mov ebx,ecx

znotgood:
		inc ecx
		cmp ecx,PictureWidth
		jb notoverwrapped

		mov edi,destline
		mov esi,offset zxbuf
		mov ecx,ebx
		add esi,ecx
		mov ecx,PictureWidth
		shr ecx,3

		movq mm7,constcolors
ms8:
		movq mm0,[esi]
		movq mm1,[esi+8]
		movq mm2,mm0
		punpcklbw mm0,mm7
		movq [edi],mm0
		punpckhbw mm2,mm7
		movq [edi+8],mm2
		movq mm3,mm1
		punpcklbw mm1,mm7
		movq [edi+16],mm1
		punpckhbw mm3,mm7
		movq [edi+24],mm3
		add edi,32
		add esi,16
		dec ecx
		jnz ms8
		emms
	}
	return;
}


void DecodeZoomLine(BYTE* destline,BYTE* sourcline)
{
	DWORD myedge;
	DWORD extraloop = (PictureWidth>>3) & 7;

	_asm
	{

		movq mm7,colormask
		mov esi,sourcline
		mov edi,offset zxbuf
		mov ecx,PictureWidth
		shr ecx,3
myloop2:

		movq mm0,[esi]
		movq mm1,[esi+8]

		pand mm0,mm7
		pand mm1,mm7
		paddw mm0,mm1
		movq mm2,mm0
		psrlq mm2,32
		paddw mm0,mm2
		movq mm2,mm0
		psrlq mm2,16
		paddw mm0,mm2
		psrlq mm0,3

		movd eax,mm0
		mov [edi],al

		add esi,16
		inc edi
		dec ecx
		jnz myloop2
		mov esi,offset zxbuf
		mov ecx,PictureWidth
		shr ecx,3
		rep movsb

		mov esi,destline
		mov edi,offset zxbuf2
		mov ecx,PictureWidth
		shr ecx,3
myloop4:
		movq mm0,[esi]
		movq mm1,[esi+8]
		pand mm0,mm7
		pand mm1,mm7
		paddw mm0,mm1
		movq mm2,mm0
		psrlq mm2,32
		paddw mm0,mm2
		movq mm2,mm0
		psrlq mm2,16
		paddw mm0,mm2
		psrlq mm0,3
		movd eax,mm0
		mov [edi],al

		add esi,16
		inc edi
		dec ecx
		jnz myloop4
		mov esi,offset zxbuf2
		mov ecx,PictureWidth
		shr ecx,3
		rep movsb

		mov edx,-1
		xor ecx,ecx
loopf:
		pxor mm5,mm5
		mov esi,offset zxbuf
		mov edi,offset zxbuf2
		add edi,ecx
		push ecx
		mov ecx,PictureWidth
		shr ecx,6
xloope:
		movq mm0,[esi]
		movq mm1,[edi]
		psadbw mm0,mm1
		paddd mm5,mm0
		add esi,8
		add edi,8
		dec ecx
		jnz xloope
		mov ecx,extraloop
		or ecx,ecx
		jz noextrra
		mov ecx,extraloop
		or ecx,ecx
		jz noextrra
		mov eax,8
		sub eax,ecx
		shl eax,3
		movd mm3,eax
		movq mm6,constffff
		psrlq mm6,mm3
		movq mm0,[esi]
		movq mm1,[edi]
		pand mm0,mm6
		pand mm1,mm6
		psadbw mm0,mm1
		paddd mm5,mm0
noextrra:
		pop ecx
		movd eax,mm5
		cmp eax,edx
		ja notgood
		mov edx,eax
		mov ebx,ecx
notgood:
		inc ecx
		mov eax,PictureWidth
		shr eax,3
		cmp ecx,eax
		jb loopf

		pxor mm7,mm7
		mov edi,offset zxbuf
		mov esi,destline
		mov ecx,PictureWidth
		mov eax,ecx
		shr ecx,4
		shl eax,1
ms0:
		movaps xmm0,[esi]
		movaps xmm1,[esi+16]
		movaps [edi],xmm0
		movaps [edi+16],xmm1
		movaps [edi+eax],xmm0
		movaps [edi+eax+16],xmm1
		add esi,32
		add edi,32

		dec ecx
		jnz ms0

		mov eax,PictureWidth
		shl ebx,3			//!!!!
		cmp ebx,eax
		jb ns_ok
		xor ebx,ebx
ns_ok:
		mov edx,ebx
		sub ebx,8
		jns nos_ok2
		add ebx,eax
nos_ok2:
		mov ecx,ebx
		add edx,8
		cmp edx,eax
		jb nos_ok3
		sub edx,eax
nos_ok3:
		mov myedge,edx
		mov eax,BlackPixels
		cmp eax,FALSE
		je notsa

		mov edi,offset zxbuf
		mov ah,[edi+ecx*2]
		xor edx,edx

bnotoverwrapped:

		mov edi,offset zxbuf
		mov esi,sourcline
		mov al,[edi+ecx*2]
		cmp al,ah
		ja notbi
		sub ah,al
		jmp notbe
notbi:
		sub al,ah
notbe:
		mov ah,[edi+ecx*2]
		cmp al,dl
		ja bznotgood
		mov dl,al
		mov ebx,ecx

bznotgood:
		inc ecx
		cmp ecx,PictureWidth
		jb bnos_ov
		xor ecx,ecx
bnos_ov:
		cmp ecx,myedge
		jne bnotoverwrapped
		add ebx,8
		jns notsacon
		add ebx,PictureWidth
		jmp notsacon

notsa:

		mov edx,-1

notoverwrapped:

		pxor mm5,mm5
		mov edi,offset zxbuf
		mov esi,sourcline
		add edi,ecx
		add edi,ecx

		push ecx
		mov ecx,PictureWidth

		shr ecx,4
ms7:

		movq mm0,[edi]
		movq mm1,[esi]
		movq mm2,[edi+8]
		movq mm3,[esi+8]

		psadbw mm0,mm1
		psadbw mm2,mm3
		paddd mm5,mm0
		movq mm0,[edi+16]
		movq mm1,[esi+16]
		paddd mm5,mm2
		psadbw mm0,mm1
		movq mm2,[edi+24]
		movq mm3,[esi+24]
		paddd mm5,mm0
		add edi,32
		psadbw mm2,mm3
		add esi,32
		paddd mm5,mm2

		dec ecx
		jnz ms7

		pop ecx

		movd eax,mm5
/*
		movzx eax,byte ptr [edi]
*/
		cmp eax,edx
		ja znotgood

		mov edx,eax
		mov ebx,ecx

znotgood:
		inc ecx
		cmp ecx,PictureWidth
		jb nos_ov
		xor ecx,ecx
nos_ov:
		cmp ecx,myedge
		jne notoverwrapped

		sub ebx,5
		jns no_sign
		add ebx,PictureWidth
no_sign:
		mov esi,offset zxbuf
		mov ah,[esi+ebx*2+1]
		inc ebx
ciklw:
		mov dl,0
		mov dh,8
		mov al,[esi+ebx*2+1]
		cmp al,ah
		jae netxt
		sub ah,al
		mov al,ah
		jmp coo
netxt:
		sub al,ah
coo:
		cmp al,dl
		jb notourss
		mov dl,al
		mov ecx,ebx
notourss:
		mov ah,[esi+ebx*2+1]
		inc ebx
		cmp ebx,PictureWidth
		jb tiki
		xor ebx,ebx
tiki:
		dec dh
		jnz ciklw
		mov ebx,ecx

notsacon:

		mov edi,destline
		mov esi,offset zxbuf
		add esi,ebx
		add esi,ebx
		mov ecx,PictureWidth
		shr ecx,4
		movups xmm6,colormask128
		movups xmm7,colorvalue128
ms8:
		movups xmm0,[esi]
		movups xmm1,[esi+16]
		andps xmm0,xmm6
		andps xmm1,xmm6
		orps xmm0,xmm7
		orps xmm1,xmm7
		movaps [edi],xmm0
		movaps [edi+16],xmm1

		add esi,32
		add edi,32
		dec ecx
		jnz ms8

		emms
	}
	return;
}


BOOL DalviDecoder2(TDeinterlaceInfo* pInfo)
{
	BYTE* PixelsOld = pInfo->PictureHistory[0]->pData;
	BYTE* Pixels;
    int i;

    if (PixelsOld == NULL )
    {
        return 1000;
    }
	if ((pInfo->FrameWidth != PictureWidth) || (pInfo->FieldHeight != PictureHeight) ||
        !IsInitialised)
    {
        if ((pInfo->FrameWidth > MAX_WIDTH) || (pInfo->FieldHeight > MAX_HEIGHT))
        {
            return 1000;
        }

		IsInitialised = TRUE;

		PictureWidth = pInfo->FrameWidth;
		PictureHeight = pInfo->FieldHeight;
		if (BigZone)
			zonelength = PictureWidth;
		else
			changemyzone();
		
    }
	if (counter > 40)
	{
		DecodeSettings(PixelsOld,pInfo->InputPitch);
		counter = 40;
		counterzone--;
		if (counterzone > 5)
		{
//			DecodeZone(PixelsOld,pInfo->InputPitch);
			counterzone = 5;
#if defined (SAVEPICT)
			if (savepic)
				if (notsaved)
				{
					savepict(PixelsOld);
					notsaved = FALSE;
				}
#endif
		}
	}
	if (zonelength == PictureWidth)
		if (ZoomPixels)
		{	
			if (UseHistory)
			{
				DWORD testline = pInfo->FieldHeight/2;
				if (pInfo->PictureHistory[1] != NULL)
					PixelsOld = (BYTE*)(pInfo->PictureHistory[1]->pData+(pInfo->InputPitch*testline));
				else
					if (pInfo->PictureHistory[2] != NULL)
						PixelsOld = (BYTE*)(pInfo->PictureHistory[2]->pData+(pInfo->InputPitch*testline));
					else
						if (pInfo->PictureHistory[3] != NULL)
							PixelsOld = (BYTE*)(pInfo->PictureHistory[3]->pData+(pInfo->InputPitch*testline));
						else
							PixelsOld = (BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*testline));


					Pixels = (BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*testline));
					DecodeLine(Pixels,PixelsOld);
					for (i = testline - 1 ; i != -1 ; i--)
					{
						Pixels = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i));
						PixelsOld = Pixels+pInfo->InputPitch;
						DecodeZoomLine(Pixels,PixelsOld);
					}
	
					for (i = testline + 1 ; i < pInfo->FieldHeight ; i++)
					{
						PixelsOld = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i-1));
						Pixels = PixelsOld+pInfo->InputPitch;
						DecodeZoomLine(Pixels,PixelsOld);
					}

			}
			else
			{
				if (Method2)
				DetectTV1000(pInfo->PictureHistory[0]->pData,pInfo->InputPitch);
				else
				DetectTV10002((BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*34)));

				for (i = 33 ; i != -1 ; i--)
				{
					Pixels = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i));
					PixelsOld = Pixels+pInfo->InputPitch;
					DecodeZoomLine(Pixels,PixelsOld);
				}

				for (i = 35 ; i < pInfo->FieldHeight ; i++)
				{
					PixelsOld = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i-1));
					Pixels = PixelsOld+pInfo->InputPitch;
					DecodeZoomLine(Pixels,PixelsOld);
				}

			}
		}
		else
		{
			if (BlackPixels)
			{
				if (UseHistory)
				{
					DWORD testline = pInfo->FieldHeight/2;
					if (pInfo->PictureHistory[1] != NULL)
						PixelsOld = (BYTE*)(pInfo->PictureHistory[1]->pData+(pInfo->InputPitch*testline));
					else
						if (pInfo->PictureHistory[2] != NULL)
							PixelsOld = (BYTE*)(pInfo->PictureHistory[2]->pData+(pInfo->InputPitch*testline));
						else
							if (pInfo->PictureHistory[3] != NULL)
								PixelsOld = (BYTE*)(pInfo->PictureHistory[3]->pData+(pInfo->InputPitch*testline));
							else
								PixelsOld = (BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*testline));


					Pixels = (BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*testline));
					DecodeLine(Pixels,PixelsOld);
					for (i = testline - 1 ; i != -1 ; i--)
					{
						Pixels = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i));
						PixelsOld = Pixels+pInfo->InputPitch;
						DecodeLine(Pixels,PixelsOld);
					}
	
					for (i = testline + 1 ; i < pInfo->FieldHeight ; i++)
					{
						PixelsOld = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i-1));
						Pixels = PixelsOld+pInfo->InputPitch;
						DecodeLine(Pixels,PixelsOld);
					}

				}
				else
				{
/*
					if (Method2)
						DetectTV1000(pInfo->PictureHistory[0]->pData,pInfo->InputPitch);
					else
						DetectTV10002((BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*34)));
					for (i = 33 ; i != -1 ; i--)
					{
						Pixels = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i));
						PixelsOld = Pixels+pInfo->InputPitch;
						DecodeLine(Pixels,PixelsOld);
					}
	
					for (i = 35 ; i < pInfo->FieldHeight ; i++)
					{
						PixelsOld = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i-1));
						Pixels = PixelsOld+pInfo->InputPitch;
						DecodeLine(Pixels,PixelsOld);
					}

*/
		Pixels = PixelsOld+pInfo->InputPitch;
		for (i = 1 ; i < PictureHeight ; i++)
		{
			DecodeLine(Pixels,PixelsOld);
			PixelsOld = Pixels;
			Pixels += pInfo->InputPitch;
		}

				}
			}
			else
			{	
				if (UseHistory)
				{
					DWORD testline = pInfo->FieldHeight/2;
					if (pInfo->PictureHistory[1] != NULL)
						PixelsOld = (BYTE*)(pInfo->PictureHistory[1]->pData+(pInfo->InputPitch*testline));
					else
						if (pInfo->PictureHistory[2] != NULL)
							PixelsOld = (BYTE*)(pInfo->PictureHistory[2]->pData+(pInfo->InputPitch*testline));
						else
							if (pInfo->PictureHistory[3] != NULL)
								PixelsOld = (BYTE*)(pInfo->PictureHistory[3]->pData+(pInfo->InputPitch*testline));
							else
								PixelsOld = (BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*testline));


					Pixels = (BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*testline));
					DecodeLine(Pixels,PixelsOld);
					for (i = testline - 1 ; i != -1 ; i--)
					{
						Pixels = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i));
						PixelsOld = Pixels+pInfo->InputPitch;
						DecodeTV1000Line(Pixels,PixelsOld);
					}
	
					for (i = testline + 1 ; i < pInfo->FieldHeight ; i++)
					{
						PixelsOld = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i-1));
						Pixels = PixelsOld+pInfo->InputPitch;
						DecodeTV1000Line(Pixels,PixelsOld);
					}

				}
				else
				{

					if (Method2)
						DetectTV1000(pInfo->PictureHistory[0]->pData,pInfo->InputPitch);
					else
						DetectTV10002((BYTE*)(pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*34)));
					for (i = 33 ; i != -1 ; i--)
					{
						Pixels = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i));
						PixelsOld = Pixels+pInfo->InputPitch;
						DecodeTV1000Line(Pixels,PixelsOld);
					}

					for (i = 35 ; i < pInfo->FieldHeight ; i++)
					{
						PixelsOld = (BYTE*)pInfo->PictureHistory[0]->pData+(pInfo->InputPitch*(i-1));
						Pixels = PixelsOld+pInfo->InputPitch;
						DecodeTV1000Line(Pixels,PixelsOld);
					}
				}
			}
		}
	else
	{
		DecodeFirstLine(PixelsOld);
		Pixels = PixelsOld+pInfo->InputPitch;
		for (i = 1 ; i < PictureHeight ; i++)
		{
			DecodeLine(Pixels,PixelsOld);
			PixelsOld = Pixels;
			Pixels += pInfo->InputPitch;
		}
	}

	counter--;
	return 1000;
}

BOOL changezone(long NevValue)
{
	BigZone = NevValue;
	if (BigZone)
	{
		zonelength = PictureWidth;
#if defined (SAVEPICT)
		savepic  = TRUE;
#endif
	}
	else
		changemyzone();
	return FALSE;
}

BOOL changepixels(long NewValue)
{
	BlackPixels = NewValue;
	return FALSE;
}

BOOL changezoom(long NewValue)
{
	ZoomPixels = NewValue;
	return FALSE;
}

BOOL changemethod2(long NewValue)
{
	Method2 = NewValue;
	return FALSE;
}

BOOL changeprevious(long NewValue)
{
	UseHistory = NewValue;
	return FALSE;
}


SETTING FLT_DalviDecoderSettings[FLT_DALVI_DEC2_SETTING_LASTONE] =
{
	{
	    "Dalvi Decoder 2", ONOFF, 0, (long*)&(DalviDecoder2Method.bActive),
        FALSE, 0, 1, 1, 1,
        NULL,
        "DalviDecoder2Filter", "UseDalviDecoder2Filter", NULL,
    },
	{
	    "TV1000", ONOFF, 0, (long*)&(BigZone),
        FALSE, 0, 1, 1, 1,
        NULL,
        "DalviDecoder2Filter", "TV1000", changezone,
    },
	{
	    "Black Pixels Only", ONOFF, 0, (long*)&(BlackPixels),
        FALSE, 0, 1, 1, 1,
        NULL,
        "DalviDecoder2Filter", "Black Pixels Only", changepixels,
    },
	{
	    "Use Zoom", ONOFF, 0, (long*)&(ZoomPixels),
        FALSE, 0, 1, 1, 1,
        NULL,
        "DalviDecoder2Filter", "Use Zoom", changezoom,
    },
	{
	    "Use Alternate Method", ONOFF, 0, (long*)&(Method2),
        FALSE, 0, 1, 1, 1,
        NULL,
        "DalviDecoder2Filter", "Use Alternate", changemethod2,
    },
	{
	    "Use Previous Frame", ONOFF, 0, (long*)&(UseHistory),
        FALSE, 0, 1, 1, 1,
        NULL,
        "DalviDecoder2Filter", "Use Previous", changeprevious,
    },

};

FILTER_METHOD DalviDecoder2Method = 
{
	sizeof(FILTER_METHOD),
	FILTER_CURRENT_VERSION,
	DEINTERLACE_INFO_CURRENT_VERSION,
	"DALVI Decoder 2",
	"Decoder 2",
	FALSE,
	TRUE,
	DalviDecoder2,
	0,
	TRUE,
	NULL,
	NULL,
	NULL,
	FLT_DALVI_DEC2_SETTING_LASTONE,
	FLT_DalviDecoderSettings,
	WM_FLT_LINEAR_CORR_GETVALUE - WM_APP,
	TRUE,
	1,
	0
};



__declspec(dllexport) FILTER_METHOD* GetFilterPluginInfo(long CpuFeatureFlags)
{
    return &DalviDecoder2Method;
}
